
function un1=CSPasso(un,dt,dx)
%
% un, vettore colonna, dt e dx scalari
% Risoluzione dell'equazione del calore u_t=u_xx
% tramite il metodo spettrale basato sulla serie di Fuorier.
% Il sistema di ODE dei coefficienti di Fourier viene
% risolto esattamente nell'intervallo dt
% Le condizioni al bordo sono supposte di tipo periodico.
%

N=length(un)-1;
L=N*dx;

% Calcolo dei coefficienti di Fourier

uu=fft(un(1:N));

% Evoluzione temporale esatta dei coefficienti

for k=1:N
   c=(2*pi*(k-1)/L)^2;
   uu(k)=uu(k)*exp(-c*dt);
end

% Calcolo della soluzione

un1=ifft(uu);
un1(N+1)=un1(1);
